#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>





int 
fastlwl(char **seq, int nbseq, int lgseq, double **ka, double **ks, double **tti0, double **tti1, double **tti2, double **ttv0, double **ttv1, double **ttv2, double **tl0, double **tl1, double **tl2, double **vka, double **vks)
{

	const double     trois = 3.0;
	double           l[3], a[3], b[3], p[3], q[3], ti[3], tv[3], cc[3],
	                aaa[3], bb[3], flgseq, va[3], vb[3],es1,es2,es3,es4,es5,es6,es7,es8;
	char            ci1, ci2, ci3, cj1, cj2, cj3, cod1[3], cod2[3];
	int             i, j, ii, jj, nbdiff, cat, pos[3], num1, num2,
	                sat, sat1, sat2;

	sat = sat1 = sat2 = 2;
	flgseq = (double) lgseq;
	if (flgseq / trois != lgseq / 3) {
		printf("Nombre de nt non multiple de trois.\n");
		return;
	}
	for (i = 0; i < nbseq - 1; i++) {
		for (j = i + 1; j < nbseq; j++) {
			l[0] = l[1] = l[2] = 0;
			ti[0] = ti[1] = ti[2] = tv[0] = tv[1] = tv[2] = 0;

			for (ii = 0; ii < lgseq / 3; ii++) {
				cod1[0] = *(seq[i] + 3 * ii);
				cod1[1] = *(seq[i] + 3 * ii + 1);
				cod1[2] = *(seq[i] + 3 * ii + 2);
				cod2[0] = *(seq[j] + 3 * ii);
				cod2[1] = *(seq[j] + 3 * ii + 1);
				cod2[2] = *(seq[j] + 3 * ii + 2);
				num1 = num(cod1);
				num2 = num(cod2);
				l[0] += *(tl0[num1] + num2);
				l[1] += *(tl1[num1] + num2);
				l[2] += *(tl2[num1] + num2);
				ti[0] += *(tti0[num1] + num2);
				ti[1] += *(tti1[num1] + num2);
				ti[2] += *(tti2[num1] + num2);
				tv[0] += *(ttv0[num1] + num2);
				tv[1] += *(ttv1[num1] + num2);
				tv[2] += *(ttv2[num1] + num2);
			}



			for (ii = 0; ii < 3; ii++) {
				p[ii] = ti[ii] / l[ii];
				q[ii] = tv[ii] / l[ii];
				aaa[ii] = 1 / (1 - 2 * p[ii] - q[ii]);
				bb[ii] = 1 / (1 - 2 * q[ii]);
				cc[ii] = (aaa[ii] + bb[ii]) / 2;

				if (bb[ii] <= 0) {
					b[ii] = 10;
				} else
					b[ii] = 0.5 * (double) log(bb[ii]);

				if ((aaa[ii] <= 0) || (bb[ii] <= 0)) {
					a[ii] = 10;
				} else
					a[ii] = 0.5 * (double) log(aaa[ii]) - 0.25 * log(bb[ii]);




es1=aaa[ii] * aaa[ii] * p[ii] + cc[ii] * cc[ii] * q[ii];
es2=(aaa[ii] * p[ii] + cc[ii] * q[ii]) * ( aaa[ii] * p[ii] + cc[ii] * q[ii]);

				va[ii] = (aaa[ii] * aaa[ii] * p[ii] + cc[ii] * cc[ii] * q[ii] - (aaa[ii] * p[ii] + cc[ii] * q[ii]) * ( aaa[ii] * p[ii] + cc[ii] * q[ii])) / l[ii];


				vb[ii] = bb[ii] * bb[ii] * q[ii] * (1 - q[ii]) / l[ii];


			}



			if ((a[1] != 10) && (a[2] != 10) && (b[2] != 10)){
				ks[i][j] = (l[1] * a[1] + l[2] * a[2]) / (l[2] + l[1]) + b[2];
				vks[i][j] = (l[1] * l[1]  * va[1] + l[2] * l[2] * va[2]) /  ((l[1] + l[2]) * (l[1]+l[2])) + vb[2] - bb[2] * q[2] * (2 * aaa[2] * p[2] - cc[2] * (1 - q[2]))/(l[1]+l[2]);
			}
			else {
				sat1 = 1;
				vks[i][j]=ks[i][j] = 9.999999;

			}

			if ((a[0] != 10) && (b[0] != 10) && (b[1] != 10)){
				ka[i][j] = a[0] + (l[0] * b[0] + l[1] * b[1]) / (l[0] + l[1]);
				vka[i][j] = (l[0] * l[0]  * vb[0] + l[1] * l[1] * vb[1]) /  ((l[1] + l[0]) * (l[1]+l[0])) + va[0] - bb[0] * q[0] * (2 * aaa[0] * p[0] - cc[0] * (1 - q[0]))/(l[1]+l[0]);
	}

		else {
				vka[i][j]=ka[i][j] = 9.999999;
				sat2 = 1;
			}


		}
	}
	if (sat1 == 1)
		sat = 1;
	if (sat2 == 1)
		sat = 0;
	return sat;
}
