#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

/*********************************************************************/
/***************************** REFRESH *******************************/
/*********************************************************************/

/* La fonction refresh modifie un tableau de sequences alignees (seq) : */
/* 	- les positions ne comprenant que des gaps sont eliminees       */
/*	- si l'argument option est passe avec la valeur 0, les positions */
/*	  comprenant au moins un gap sont eliminees.                   */
/* nbseq est le nombre de sequences passees.                           */


void refresh(char** seq, int nbseq, int option){

/* Si option = 0, toutes les positions avec au moins un gap sont eliminees */
	


#define maxnseqs 100
int lgseq, l, drapeau, i, j, k;
char *seqref[maxnseqs] ;

	lgseq=strlen(seq[1]);
	for(i=0;i<nbseq;i++)
		if ((seqref[i]=(char*)malloc(lgseq*sizeof(char)))==NULL){
			printf("Erreur d'allocation");
			exit(1);
		}

	l=-1;
	if (option==0){
		for(i=0;i<lgseq;i++){
			drapeau=0;
			for(j=0;j<nbseq;j++){
				if (*(seq[j]+i)=='-') drapeau=1;
			}
			if (drapeau==0){
				l++;
				for(k=0;k<nbseq;k++) *(seqref[k]+l)=*(seq[k]+i);
			}	
		}
	}
	else{
		for(i=0;i<lgseq;i++){
			drapeau=0;
			for(j=0;j<nbseq;j++){
				if (*(seq[j]+i)!='-') {
					drapeau=1;
					break;
				}
			}
			if (drapeau==1){
				l++;
				for(k=0;k<nbseq;k++) *(seqref[k]+l)=*(seq[k]+i);
			}		
		}
	}
	for(i=0;i<nbseq;i++){
		for (j=l+1;j<lgseq;j++) {
			*(seqref[i]+j)='\0';
		}
	}

	for (i=0;i<nbseq;i++) {
		for (j=0;j<lgseq;j++){
			*(seq[i]+j)=*(seqref[i]+j);
		}
	}
}
